Tag Archive | tutorial

Setting up your Revit project for inputting macro codes

I have decided to write a blog following on from Harry’s post on the Boost Your BIM blog. Here Harry explains how to set up your Revit project to use the macro codes which he is kindly sharing on his website, or any other macro code in this case. If you are still in doubt about how to set up your project, follow this tutorial for simple, step-by-step instructions.

Open up Revit and make sure you have a project open which you wish to use this code on – Although the Macro profile you set up will be saved and available to use on all future projects as well, if you follow the instructions below.

Head over to the ‘Manage’ tab on the ribbon – click on ‘Macro Manager’ – You will now see a dialogue box with several options. At the top you see the 2 tabs ‘Application’ and the active tab ‘Name of project’. This is where you make the decision to either implement a macro code for ONLY the project your working on, or wether the macro settings will be saved for the application (Revit). In this case and most others, you will be using ‘Application’..

uploaded image

Click on the ‘Application; tab – If this is the first time you are setting up a macro, you will need to create a new ‘Module’. You can think of the module as a folder containing all your files (macro codes). Click on ‘Module’ on the right hand side under the ‘Create’ options. 

uploaded image

Create a new module by giving it a name, choosing which language the code was written in (if your only using Boost Your BIM code, this will always be C#) and giving the module a short description, as shown in the image above.

uploaded image

As soon as you have created a new module within Revit, you will notice a new application opens, SharpDevelop. This is the application which Revit uses to allow users to input their own macros. This will also be the place where you will input your code in order to run your programs within Revit. 

uploaded image

Before we do anything in SharpDevelop, we need to open Revit back up and create a macro, inside of the module we just created. Make sure your Module is highlighted, and simply click on ‘Macro’ on the right side under the ‘Create’ options. A dialogue similar to the module creation will appear. Again, give your macro a name and a short description. Make sure there are no spaces or invalid characters in the name field. I would recommend using a name such as MyFirstMacro.

uploaded image

Head back to SharpDevelop, you will now see a new peice of Revit macro generated code (pictured above), if you used the name I suggeste, the new code will look like this public void MyFirstMacro() followed by a { + } inside these brackets is where we will insert our code. If you have absolutely no knowledge of programming languages, you can think of these as the front and back cover of a book, with all the information (code) inside the covers. Each new macro we add to our module will have the same set up, just with a different name.

uploaded image

After this we must enter some new values at the top of the code to indicate which libraries we are referencing when we call functions in our code. Head to the top of the code in SharpDevelop and find the text ‘using System;’ underneath this you will need to add the following, 1 statement per line. Using Autodesk.Revit.UI; Using Autodesk.Revit.DB; using Autodesk.Revit.UI.Selection; using System.Collections.Generic; using System.Linq; (Pictured above).

uploaded image

We are now ready to input our code. If you are using code from the Boost your BIM blog, you will need to highlight the following code, ensuring you leave out any code which is not highlighted in this example (Pictured above). Be sure you do not copy extra { or } parenthesis as this will result in a fail when you try to build the code. A book only has 1 front and back cover! 

uploaded image

Once you have copied the code, paste it in between the { + } parenthesis. You may now wish to try and build your code and check to see that everything is responding as it should be. Click on the ‘Build’ tab at the top of SharpDevelop and then click on ‘Build solution (F8)’. You may notice a loading bar appear in the bottom right of the application as your module is being built and checked for errors. 
uploaded image

Your code should compile, and hopefully with no errors! If this is the case then you can return to Revit and see your Module with the new Macro embedded inside as shown above. You can now highlight the macro you have just created and click ‘Run’ on the right hand side to run your macro in Revit.

If you are receiving compilation errors, you may wish to check out these 2 posts over at Boost Your BIM to help troubleshoot the problem. If you still can’t solve your error, Harry invites you to contact him to discuss it further.

Many thanks again to Harry for posting all these useful macros and helping new users understand and solve problems relating to the Revit API. Be sure to subscribe to his Boost Your BIM blog and follow him on Twitter @BoostYourBIM

Advertisement

Single day solar study – Animate your Elevations in Revit

Are you looking for a way to present your elevation views in Revit? Find the default view a bit boring? Well here’s something new you can try. There are many different graphic display options which you can set within Revit to make your views more aesthetically pleasing. We all know about turning on/off shadows and changing from hidden line to realistic with edges etc – But have you tried a single day solar study on your elevation view? If you’d like to know more continue reading!

uploaded image

Once you have selected which elevation you want to work on and on the correct view, head down to your view control bar and click on the 3D cube, as shown below. Click on ‘Graphic Display Options…’ to bring you to the next step. Depending on how you want your elevation to appear in your animation, you may wish to change the view to Realistic or one of the other options now.

uploaded image

For this example, I have decided to use a realistic style with Silhouettes set to Wide Lines. This will make the strong lines and edges of your buildings stand out more, similar to if you’re hand sketching and you draw over and make these lines thicker to make the sketch “pop”. If you have set up your own line styles, you will also be able to use them as an option.

uploaded image

You should now head to the Shadows tab and turn click the selection boxes for ‘Case Shadows’ and ‘Show Ambient Shadows’ – Cast shadows are the default shadows you will see when you turn on shadows from the view control bar. ‘Show Ambient Shadows’ are basically an extra layer of shadows on top, which particularly accentuate areas such as the area under the canopy as you see in the elevation view above.

uploaded image

Now you have completed your shadows it’s time to move on to ‘Lighting’ options. Here you have many options to create different outcomes – We are, for this example going to use the ‘Single Day’ study, this will generate an animation based on a single day, in a single location, between a time period (which we also decide). Set up the parameters so that they are according to your project. (Location and date should already be shown if you have set up your project correctly.) I have chosen the option ‘Sunrise to sunset’ which it tells us will record from 8AM to 15:30PM. Select your ground reference level, save settings and apply. ‘Time Interval’ is important and will determine the length of our final animation, set it from 15 minutes – One hour depending on how often you want to update your animation. 

uploaded image

If you decided to use the same settings as me, you will notice your elevation now appears very dark. This is because we set our times from sunrise to sunset, with the first frame being at 8AM when it is still dark (you can revert back to your original settings at any time.) I have also turned ‘Photographic Exposure’ on and set it to automatic, this will make the view appear more realistic, but will also slow down the time it takes for your animation to be exported. Head to the ‘Background’ tab and select Sky in the dropdown menu (or use an image if you’d prefer). You may also wish to select a ‘Ground Color’ as I have above. 

uploaded image

Now you have set up your elevation view, it is time to export the animation as a ‘Solar Study’ with an .AVI output, as shown above – Click on the Revit menu, head down to ‘Export’ you will then need to hover your mouse over the small arrow bar on the Export menu until you scroll down to ‘Images and Animations’ select ‘Solar Study’ where you will be taken to the next screen to set up your rendering options.

uploaded image

The next dialogue titled ‘Length/Format’ gives you options for selecting the size and length of your animation, as I have selected hourly intervals, if I select a high frame rate for example 50 fps, you will  notice the Total time: going to 0 seconds. In order to have a suitably lengthed animation, I have set the frames/sec to 10. Your visual style should already be set, and now you have to choose how big you want your animation video to be. For example purposes I have reduced the size to 50% of actual size. After setting up and hitting okay, you will be see another dialogue asking which compression method to use, in most cases ‘Full (Uncompressed)’ will be fine. Click ok, and wait for your animation to be rendered, this should not take long considering the low frame rate we have selected.      

uploaded image

Your animation is now complete and saved to the directory you specified. You will notice that the length of the video is probably too short, you can use video editing software to slow it down to give a better result to view your single day solar study. I have for this example used ‘Windows Live Movie Maker’ as most people will have it as default. Click on Add photos and videos, and select the .avi which you have just created. Once the video is added, click on it, and then head to the edit video tools tab and change the speed to x 0.125 – making your video 8x longer than it was originally. Head to the file menu and click on ‘Save Movie’ choose either for computer or high definition display and click save. 

You will now hopefully have a video which is aesthetically pleasing an long enough for presentation purposes. It is also a good way to share your solar study with others, and to analyse the solar and shadow settings over a full day, in a particular view in Revit. My example is slightly jumpy as the frame rate is set to low. Play around with the settings yourself until you find the result you are looking for. Any questions, leave a message or contact me on Twitter.

 

Dormers and openings in Revit

Today I am posting a small tutorial about creating dormer / dormer openings in Revit Architecture. It is a very simple process but has a few steps, so if you are having problems with dormers or interested in learning, continue reading.

The first step is to create some temporary walls as shown in the image below, indicated by the red rectangle. You should place these walls on the level under your roof, if you only have 2 levels, that’s fine, they will be cleaned up later and will not be visible. As usual take note of which wall type you are using. 

uploaded image

 You can now switch to a 3D view. You will see the walls protruding through the roof. I would recommend setting up levels to constrain the top of the walls, you can also define an unconstrained height. The next step of the proccess is to create a roof for these new walls you’ve created. Select ‘Roof by extrusion’. You will need to select a level to indicate which workplane you are working on. Choose the new level you have just created which is constraining the top of the walls as shown in the image below.  

uploaded image

 Once you’ve selected your work plane, you are ready to start sketching. This is another simple step. You need to create 2 lines as shown in the image below, each one connecting to the center point of the walls. Once you have created these 2 lines, highlight both of them, and use the blue node connector to drag up and create the angled profile that you desire.

uploaded image

You have now created a roof extrusion, but as you can see it doesn’t look as it should. What you need to do now is connect the new roof to the existing roof. You do this with the ‘Join Roof’ tool. Select the back edge of the roof, you can do this by pressing tab until the neccesary face is selected. Once selected, join the roof to the front face of the existing roof, again use tab to select the correct face. If you rotate the 3D view you will now see the roof is properly connected.

uploaded image

Now you need to connect the walls to the top of the roof. This is of course done with the ‘Attach top / base tool’. Select all 3 of the new walls you have created and click attach the TOP to the newly created roof. Once the walls are attached, reselect all 3 walls and attack the BASE to the main roof, this will resolve the problem of the walls being created on a lower level. 

uploaded image

The final step is creating the dormer opening in the roof. Right now in your model you have a new construction created on top of the roof, so a roof opening is needed. We do this with the ‘Dormer’ tool shown in the image below. Once you are in the dormer creation window select the lines of ALL edges of the new construction you have created. Use the blue arrows to position the lines on the inside of the walls. Trim / extend all edges to create a closed loop and create a group. Click the tick to finish.

uploaded image

You can now add a window or an opening to your dormer. Revit has many options to choose from, but if you can’t find something that fits then create a custom one from a generic window family template or alternatively search one of the online family databases where you may find what your looking for.

uploaded image

This is a repost of an old blog which I decided to post after receiving a question on YouTube about making openings in roof for dormers. Hope that this answers your questions..

 

Opening / Closing door – Revit Family Tutorial

In this post I will be showing you how to create a door family in Revit 2013 which can open and close as well as being fully parametric. If you are new to family creation you may wish to check out the tutorials section of my website and follow the family series from the beginning. Click here to view previous tutorials. 

The first thing you need to do is open a new family. Open up your Revit > New Family > Load a Generic model wall based. The first view we will be working in is the “Placement side elevation” navigate to this view, and set out reference planes with dimension parameters exactly as I have in the image below. Use type parameters for the ‘Width’ and ‘Height’ dimensions. 

uploaded image

The next thing we need to do is create an opening where our door is going to be located. We have already set out our reference planes for the opening above so all we need to do is click the ‘Opening’ icon in our ‘Create’ tab. Use the rectangle line creation tool to draw an opening over the reference planes we have just created. Be sure to lock the opening to the reference plane at the bottom and not the reference level as you see in the image below.

uploaded image

You should now see an opening in the wall if you look in a 3D view. Navigate to the reference level view. We now need to draw a reference line which will be used as a reference for our door swing angle. Draw a reference line from the right corner of our wall out at an angle. (It doesn’t matter what angle for now as this will be editable after we give it a dimension and parameter. Your reference line should be drawn as shown in the image below.

uploaded image

Now that we have a reference line where we want it to be, we need to align and constrain it to the outside of our wall. We will do this by clicking on ‘Align’ in the ‘Modify’ tab on your ribbon. Once we have activated the command we need to align the bottom corner of the reference line to the right reference plane which is controlling our door opening as shown in the image below. It is crucial you find the bottom point of the reference line – cycle through your selection options with the tab key until you see the little point on the bottom of the reference line as shown below.

uploaded image

Once we are sure that our reference line is locked to the reference plane we can create a new dimension and parameter for the door swing angle. Go to the ‘Annotate’ tab and click on ‘Angular’ dimension. Click the reference line and then the reference plane as shown in the image below. Give this dimension another parameter as we have done on the previous dimensions. I have called this ‘Door Swing Angle’.

uploaded image

We must now create the extrusion for our door, but before this we will need to set out new references for the geometry. Set your ‘Door Swing Angle’ to 90* so that it is fully opened (this will allow us to use the reference line it was created on as our workplane.) You should now head to your ‘Left elevation’ view. We now need to set the reference line we have just draw as our work plane. Click on ‘Set’ on the ‘Create’ tab. You should now select the ‘Pick plane’ option and click ok. If you select the wrong reference line Revit will force you to open another view, if you get this message you have selected the wrong reference. Cycle through with tab until you find the correct line. Click on ‘Show’ to show the reference plane and check you are working on the correct plane as shown below.

uploaded image

Once you are sure you are working on the correct reference line we need to create some more reference planes to constrain the geometry for our door which we will be drawing in the next step. Draw 3 new reference planes as shown in the image below. Be sure that your right reference plane is on the placement side of your wall. (highlighted in the image below) 

uploaded image

Once we have our new reference planes set out, you need to create an extrusion as shown in the image below. Be sure to lock your geometry to your reference planes! I have also set ‘Extrusion Start’ to 40 to give the door a 4cm thickness, I have also at this point assigned a material instance parameter so it will be possible to edit the door material once it is in a project environment. 

uploaded image

We now need to dimension and give parameters to the extrusion we have just drawn. As we have already set up parameters for the height and width of our door opening, we will use the same ones to define the dimensions of the door extrusion. Be sure to dimension from reference plane to reference plane rather than using the actual geometry – Remeber we’ve locked the geometry to the reference planes. Once you’ve created the new dimensions just click the dimension value and change the parameters to ‘Width’ and ‘Height’ accordingly. You should see the dimensions of the door change automatically when you apply the parameters. 

uploaded image

Your family parametric opening door is now complete! Look in the 3D view and try and flex your family. Make sure that the ‘Door Angle’ and the other dimension parameters are working correctly before you save your file. Once you are happy that your family is flexing correctly you can save your family and load it in to your project. You will now have a 3D door which you can open and close – This will also show up in plan view as a door with a user defined opening rotation.

If you have any questions or feedback then please leave a comment below! 

Extrusion with curved edges on all 4 sides

Recently when creating families in Revit, I came across a problem. When creating a square extrusion, lets use for this example a table top. If you want to have curved edges on the front and back edge of the table, it is possible to draw your extrusion in an elevation view e.g. Elevation left, as shown below. What you will achieve is, as you would expect a rectangle extrusion with rounded edges as you have drawn the profile in the elevation.

uploaded image

But what happens, if you want to turn the other 2 flattened off edges on either side in to a rounded edge? I thought this would be easily achieved by going to the front elevation view as you see below and editing the extrusion and then modifying the profiles of the edges on both sides in the same way I have done when I created the original extrusion. Unfortunately, this is for some reason not possible and Revit gives you a dialogue box where you are forced to change view if you want to edit the extrusion. It is therefore only possible to edit the extrusion in a Left or Right Elevation view as shown below. This will not help us as it is the same view in which the original element was created.

uploaded image

I therefore tried various workarounds, and achieved a solution through the use of void extrusions. Open up the front elevation view where you want to add the profile and draw a square exrusion in the corner of extrusion you are editing baring in mind the dimensions of your model. After this, use a tangent arc to join the edges and create a curved profile as you see below. Draw the extrusion exactly as you see it and make sure that it is formed in a closed loop.

uploaded image

Once you have created the Void Extrusion, you will see that it is a small block in the centre of your original extrusion. You now need to apply the rounded edge over the whole edge of the table top. You can do this by navigating to your left elevation view where you can stretch your new void extrusion so it is covering the corners of your table top surface. This will now create a neat joined surface with curved edges on all sides.

uploaded image

As shown below, this is a valid work around, and can still be locked to work planes to create a parametric surface. Although it gives the result I was looking for, I am sure there must be a better method to achieve the same results. I tried it with all the modelling tools and this was the best outcome that I could come up with.

uploaded image

If anyone knows of a better method to do this, please let me know as I would love to know an easier way to achieve this fairly common type of finish for furniture etc. Leave a comment and I will get back to you ASAP.

 

Creating simple parametric families in Revit – Part 4 – Coffee Cup

In the fourth part of my ‘Creating Revit families’ series I will be demonstrating how to design and model a 3D coffee/tea cup in Revit. If you are new to creating families and wish to learn some more of the basics, you may want to check out Part 1 – Parametric cubePart 2 – Parametric tablePart 3 – Parametric window If you are already familiar with creating basic families, and you want to learn about some of the more advanced features of creating families used in the Coffee cup family (revolves, sweeps, blends etc.) then continue on to the following instructions:

uploaded image

As with all new families, the first thing we will need to do is open up a template. In this case, we will use the “Metric Generic Model face based” – This will allow us to host the family to a face / surface for instance a table top. Always consider where you family is most likely to be hosted before deciding which template to use.

uploaded image

The first thing you are going to need to do is set out some reference planes to use as markers / constraints. Head to your “Front elevation” view. At this point, bare in mind that most of the templates are designed for large objects, such as roofs panels / building objects. Due to this reason, the generic reference planes will be a lot larger than we need, you will therefore need to resize the reference planes and change the scale to 1:1. Once you have done this, you should set out your reference planes exactly as you see in the image above, unless you want a slight variation to my design.

uploaded image

Now our reference planes are set up, we want to make the overall ‘form’ of the cup. To do this there are various methods, but the method I prefer is to use a solid revolve. Therefore pick the revolve tool under the ‘Create’ or ‘Architecture’ menu (depending on which version of Revit you are using). Sketch your revolve profile as shown in the image above, take note you only have to draw half of the object as the Axis line acts as mirror, or line of revolution for cylinder like forms. Follow the steps below before you finish your Revolve.

uploaded image

Assuming you don’t want a square edged coffee cup, we will need to create profiles on the edges of the revolves in order to give a nice rounded finish to the rim and bottom of the cup. First of all, just draw the corners as rectangles as illustrated above. Once you have done this, you want to use the  ‘Fillet arc’ tool to create the corners. As shown above select the tool and make sure the ‘Radius’ box is ticked in the actions bar, you can play around with the radius dimension to find your desired curve, I have used a 1mm radius in this instance. Make sure as always to lock your geometry in position with the reference planes.

uploaded image

If you look in your 3D view you will now see something that is beginning to look like a coffee cup. The next step is to create a handle for the cup. I am working now on the ‘Right Elevation’ view. You should set up as before, reference planes in your ‘Right elevation’ to constrain the handle as shown above. We are now going to use the ‘Solid Sweep’. A solid sweep is created in 2 steps. Firstly, as shown above, we are going to create the line or the ‘Path’ that the desired geometry will follow. Once we have set the path, we will need to create the profile, this is how the path will be extruded as a 3D object rather than a 2D path line. Go to Home > Sweep > Sketch path and follow the instructions above to create a handle shape. Click the tick to finish your path.

uploaded image

Be sure to only click the tick once, as we are yet to make the 3D profile. Click the ‘Select Profile’ button on the ribbon followed by the ‘Edit profile’ you will now be asked to choose which view you want to sketch it in, select the ‘Elevation Right’ You should now see a head on view with a cross with a point in the middle. The point is representing the middle of the path you have just drawn. (Imagine we are just stretching this point to create the desired thickness.) We now want to set up reference plans and sketch the profile for the cups handle, I have used an almost circular shaped geometry but feel free to play around with the profile shape. Once you have done this, click the green tick twice to complete your Sweep.

uploaded image

In your 3D view you should now see an empty coffee cup with your new handle attached correctly. Now we need to fill it with some coffee!! To do this, we will again use the solid ‘Revolve’ tool. Use a dimension line to constrain the level of your coffee, you may also want to set an instance parameter for the level of your coffee if it is important to you how much coffee is in the cup ;) Follow the image above if you wish to create an almost full cup, pay attention to the bottom corner of your revolve as you do not want it to be protruding your actual cup geometry!

uploaded image

The final step we need to take in the family environment is to set some parameters for materials, so whoever will use the coffee cup family will be able to set custom materials for the cup. Assuming you want the handle to be the same material as the cup itself, create two new parameters, one for cup and handle material, and the other for the coffee liquid material. Follow the steps in the image above if you are unsure of how to do this. Finally save your family with an easily recognisable name and load it in to a project to test out.

uploaded image uploaded image

You can now add custom colours and materials to your coffee cup as shown above, unfortunately I didn’t have a liquid coffee texture, so had to settle with ‘Murky water’ – I wouldn’t drink it, but the cup is doing it’s job! Hope this helps anyone who is having problems with some of the more advanced tools in the Revit family creation environment. With the basic understanding of the tools we have discussed today, it is easy to start designing your own objects, try for yourself and see how you get on! Next time I will be discussing adaptive points in the family environment.

Creating simple parametric families in Revit – Part 3 Window

Part Three of my Revit architecture family series will be about creating simple parametric windows. If you missed the First part or the Second part, follow the links to bring you up to date. These tutorials are starting from the very basics of family creation all the way up to detailed advanced families. If you are having problems with windows or new to window familes, use the tutorial below as a guide.

uploaded image

The first task you need to perform, is to open up a ‘Generic Window template’ as a new family in Revit. Once you have this template open, you should see, in reference/plan view an image similar to that you see above. In this case, I am not going to be tiling my screen as it will be easier to work with the views as we need them for a window family.

uploaded image

Now you want to navigate to 3D mode, as shown in the image above. The first bit of sketching you need to do, is to create a solid sweep following the path of your window opening. (NOTE: If you do not want your window to defined by height width, then it is essential to edit your window opening before you proceed, in this case we’ll keep it simple). Use the pick path tool and create a closed loop. The green square is representing the workplane/area that you will be creating your profile on.

uploaded image

Once you have finished your sweep, and BEFORE you click the green tick to end the command, you will want to click on ‘Edit Profile’ as shown in the image above. It will now be a good idea to go into a Left or Right elevation view to create your window frame / profile.

uploaded image

As shown in the image above, I am creating my blend profile in a Right elevation view. This is the most important step in creating a basic window family. The profile / sketch you draw now, will define how your window will look. Sketch a profile similar to the one I have shown in the image above. It is your choice how far you want the edges of the frame to extrude from the wall etc, so play around with this profile if your not satisfied.

uploaded image

In the above image, you can see I have created two new aligned dimensions. The first, set by me to 120mm is for the internal frame of the window, and will define the thickness of that. The second dimension, with the EQ property is very important. We are measuring from the outer edge of the profile, to the MID-Point reference line and then to the outer edge of the profile. Once we have done this, click the small EQ sign above the dimensions to give an equal dimension to both measurements. This step is crucial, as this will mean we can use this window on walls of varying thickness, and not just this exact size of wall. Once you are satisfied, click the green tick twice to end the profile and sweep.

uploaded image

Once you have finished editing your sweep, you should go into a 3D view and check you are satisfie with the frame that you have created. As you can see, I have chosen to design a window with a LARGE surrounding frame, what you do is your choice. The next step is to create some glass to go into our window, but before we do this, we need to make sure we are working on the correct workplane. To do this, follow the steps in the above image, click Create > Extrusion > ‘Set’ Work Plane. You want to select the Reference Plane: Center (Front/Back). This happens to be the same reference plane that you have created your EQ dimension to. This should help you understand the importance of those dimensions.

uploaded image

We now simply use the ‘Pick Line’ tool in the create extrusion ribbon and make sure the ‘Lock’ option is ticked and selected. Choose the inner edge of the frame and create a closed loop as shown in the image above. You can also change the ‘Depth’ (thickness) of the extrusion here, alternatively use the element properties to define the size.

uploaded image

You will now see a solid extrusion filling the space of the window, so of course, what we want to do is to change this extrusion mass to a ‘Window’ or ‘Glass’ material. We can be fairly sure that in any case we want to use this window, this layer will be Glass. For the frame, we may wish to choose a custom material depending on our project, If you don’t know how to do this by now, then simply follow the steps from the image above. Now you will be able to define the material of the window frame in a project environment.

uploaded image

As when creating any family, it is a good idea to include a few extra design options as standard. This can save time and means you don’t have to go in and edit the family every time you want a different dimension of the window. Create 3 or 4 different sizes following the steps above and then save your family. It is a good idea to save all your families in the same place, once you start to create many different families it is a good idea to organise them with a good folder structure.

uploaded image

Finally, load your family in to a project. As an example, the above image shows 4 of custom windows I just created. As you can see on the left of the image in the element properties dialogue, there are various design options, e.g. Sill height and ‘Window Frame’ material. And that is all, another very simple window family. I hope that this gives anyone wanting to create a custom window family some good tips and direction. Look out for part 4 in the Revit parametric families series coming soon!

Click here for Part 1 and Part 2 of the Revit Family Creating series

Or Click here for Part 4 of the series – Learn to create a coffee cup in Revit

Creating simple parametric families in Revit – Part 2 Tables

Today I will be posting the 2nd part in my Revit family creation series. I started last week with the very basics of parametric family creation, and will be going more in depth over the coming weeks, starting with part 2 today; Creating a simple table in Revit Architecture 2013. I have avoided repeating the basics that I covered in part 1, so if there is anything that you are not clear about, watch part 1 now.

Firstly, you will want to open a new Revit family template. For this instance, we are going to use the ‘Metric Generic Model’ template. The first thing we are going to do, like in any family creation is to set out the boundaries, or in Revit, the ‘Reference planes’. You will see 2 reference planes, 1 on the X-axis and 1 on the Y-axis. You will want to create 2 new reference planes to start with. Once you have created the new reference planes, you should add 2 aligned dimensions as shown in the image below.

uploaded image

You have now set up your reference planes for your table top surface. To make these reference planes into the boundary lines of our surface, we will need to add labels to and lock the dimension lines in place. We do this by adding a parameter to our dimension in exactly the same way as we did in part 1. This time, we are going to call the 2 dimensions ‘Table Height’ and ‘Table Width’ both of these should be ‘Type parameters’. You do not have to worry too much about the actual size of the table at this point. Be sure to lock your dimension lines in place. 

uploaded image

Once your dimension lines are locked, labled and in place, you are ready to begin some actual massing. We are going to add geometry by using the Create > Extrusion tool. There are many ways to create this extrusion. My prefered method is to draw a rectangle roughly in the middle of your reference planes. I now use the Align tool, to align my extrusion edges to my reference planes. By doing this, we can make sure to manually lock our mass to the reference planes on each line of the mass. 

uploaded image

You should now refer to an elevation view. You will see that you have only 1 default reference plane, where our table top is hosted. We will need to create a new reference plane here which will host the desktop of the table. To o this, we create a new reference plane and name it ‘Desk Height’. Once the reference plane is created, we can click on our desktop mass and click ‘Edit Workplane’. We can now select the new ‘Desk Height’ workplane as the host. Create an aligned dimension between ‘Ref. Level 1’ and ‘Desk Height’ and be sure to lock it in place..

uploaded image

Once we have our desktop in the correct position, we need to think about adding some legs to the table. We should now switch back to the plan view of the project. Again, we will need to use reference planes to define our table legs. Offset all of the reference planes which you have created by 100mm (or the desired thickness of your tables legs) using the ‘Pick lines’ tool. You should now see something similar to the image above, with 8 reference planes. 

uploaded image

We will now, of course, add dimensions to our reference planes to lock them in position. We will again add a parameter to each one of these dimensions, but this time label it as “Legs Width”, this should again be a ‘Type’ parameter. Once you have labeled and locked one of the dimensions in place, you can then highlight all the other dimensions and use the same “Legs Width” parameter. You should now have 4 new dimensions with the “Leg Width” parameter, as shown in the image above. 

uploaded image

Using the exact same method we used to create the desk top, we are going to now use to create the tables legs. Create > Extrusion and draw a rectangle roughly around where you want to have your tables legs. Align each edge of the table legs to the reference planes, and LOCK them in position. It is very important to lock your dimensions or you will end up with a strange looking table! Create your 4 table legs and hit, the tick to finish your extrusion.

uploaded image

Refer back to your elevation view and add a dimension for the height of the table. I have choosen to label this ‘Type’ parameter as ‘Desk Height’. Once you have this dimension set and labeled, you will now be able to select the legs of your table, and constrain the ‘Extrusion End’ to ‘Desk Height’ as shown in the image above. You will now see your legs attached to the desk top of the table. 

uploaded image

You should now hopefully see an object which looks like a basic table, as shown in the image above. Now, the great thing about creating families like this, is that we can set different design options, and sizes very easily. I will make 3 different default sizes to save me time when I am using the family in a project. To do this, we click on the ‘Family Types’ Icon in the top left of our ‘Create’ ribbon. It is now possible to add new types of the same table. Click new, call your family something appropriate E.g. ‘Table 1×2’ and then change the dimensions accordingly. 

uploaded image

The last thing we are going to do in the family environment is to allow custom materials to be set for the table. In this case, we need to set a parameter for ‘Leg Material’ and ‘Desk Material’. We do this by click on the small grey box in the material properties, once we click on an element. Click on the legs of the table and then the small grey box. A new window will open, where you should click ‘Add Parameter’. This time we should name it ‘Legs Material’ make sure it is in the Materials and Finishes group, and set it as an INSTANCE parameter. Do the same thing for the table top, and we are just about ready to load this family into our projects. Save the family and close.

uploaded image

We can now open a new project and enter our new family as a component. When you load the family, you will see there are 3 variations to choose from. (Depending on how many uniquely dimensioned tables you choose to create.) You will also be able to click on ‘Edit type’ in the properties panel to change the dimensions, also notice that you have customisation options for selecting ‘Leg Material’ and ‘Desktop Material’. Choose the options that you need, and your new table family is complete. As you can see, creating basic families like this in Revit is very simple, and the same basic rules apply for creating more advanced geometry. Stay tuned for part 3 of the ‘Creating simple parametric families in Revit’ tutorials.

Click here if you  missed Creating simple parametric families in Revit – Part 1

 

View Part 3 here – Creating simple parametric families in Revit – Part 3 Window

Creating simple parametric families in Revit – Part 1

Today, I will be showing you how to create simple parametric families in Revit. This tutorial is for anyone learning Revit who hasn’t yet got into creating families. I will be continuing to post more family tutorials so keep checking back over the coming weeks for more. This tutorial will show you how to create a simple ‘cube family’ with a fixed elevation height with parametric width and height as well as material options. 

The first thing you want to do, is to create a new generic family template. When deciding what template to use, you should take into consideration what kind of family you are creating. For example, if you are creating a light fixture, you would of course use the light fixture family template. Be sure to think about where the family will be hosted, if it will be hosted on the ceiling, make sure you also use a ceiling based family. 

uploaded image

Once you have your generic family template loaded, you will want to tile the windows. (Be sure you have no other active projects open) The reason you want to do this is to give you a good overview of all relevant views when creating your family. Plan view, Elevation front, Elevation left (or right) and 3D view. 

uploaded image

Now you should see 4 equally sized windows fitted to your screen. In case the view has been obscured, zoom to fit in each window (double click mouse wheel). Now the most important part about creating families is using reference planes. Reference planes are crucial when designing families, as these will act as your control dimensions / constraints. Create a square with 4 seperate reference planes as shown in the image below. Always remember to draw your reference planes clockwise, this will be important for future developments. 

uploaded image

Now you have set constraints to the floor plan view of the project, it is now time to set some elevation height constraints. We do this with the use of dimensions (di), by adding a dimension line to our elevation view. If you have a certain height you want your cube to be, then measure it off here, otherwise, for now just follow the example shown in the images below. 

uploaded image

Once we have set some dimensions on our reference planes, we want to give these dimensions a parameter. Parameters are used to give custom or fixed assets to our families. Now you want your elevation view, where you have just created a dimension to be active. Highlight your dimension and click on the dropdown menu next to label, as shown below. To start with, the only option you will see is ‘Add parameter…’uploaded image

We are now going to add a parameter to this dimension line, constraining the elevation height of the cube. As shown in the image below, we will create a name for this dimension parameter ‘Height of cube’. Be sure the ‘Group parameter under’ option is set to ‘Dimensions’ In this case, we will keep it as a ‘Type’ parameter. This means that we can use this parameter to constrain the height of the family to the ‘Height of cube’ parameter, which you can see is ‘2214mm’.

uploaded image

Once you have created a parameter for your ‘Elevation left’ view, you will want to do the same thing for your dimension lines you created on the ‘Floor plan’ view. Click on the dimension defining the height and add a new parameter label. This time we will call the dimension ‘Height’ again checking it is set as a dimension. This time we will use an ‘Instance parameter’ so click the ‘Instance’ checkbox. Instance parameters will give the user of the family the option to define custom settings, in this case height for the cube. Follow the exact same steps mentioned above for your ‘Width’ dimension on the ‘Floor plan’ view. You will now have 3 dimension, with 3 new dimension labels.

uploaded image

Now, once our template is set up and constrained we are going to start creating some actual physical geometry. We do this of course with the Revit massing tools. As shown above, navigate to the ‘Design’ tab and click on ‘Solid Extrusion’. You now want to draw a box with the square line creation tool, covering the reference planes you have set, as shown in the image above. Before you finish your extrusion, you want to edit some of the extrusion properties.

uploaded image

We are now going to modify the ‘Extrusion End’ constraints, otherwise known as the elevation height, or extrusion height. Click on the small grey box at the end of the ‘Extrusion End’ bar. You will now see the ‘Associate Family Parameter’ dialogue appear. You will also see the 3 new paramaters you have just created. As we are now trying to define the extrusion height of the cube, we will select our ‘Height of cube’ parameter. Click OK. You will now see that the ‘Extrusion End’ bar is greyed out.

uploaded image

The final parameter we are going to add is to be for a material. The reason we do this, is so that the user of the family, in a project environment will be able to choose which material they want the family to be. For more detailed families it is possible to split the materials into different sections, but I will be discussing that in another post. For now, we want to add a parameter for the material. Simply click on the small box at the right side of the materials bar and click on ‘Add parameter…’ We will name this parameter ‘Cube Material’ and make sure it is set as a ‘Material and finishes’ parameter and set as an ‘Instance’.

uploaded image

You can now finish your extrusion by clicking on the green tick in the modify extrusion ribbon. You should now be seeing something similar to the image above. If not, make sure all of your views are active and zoomed to fit. You can now save this family. Revit > Save As > Family – I like to add all my custom families to a new folder I have created in the Autodesk library, that way they are all stored together, but you can choose to save it wherever suits you best.

uploaded image

Once you have saved your family, Use the Revit > Close button. You can now open up a new architectural project file template, or the project where you want to add your newly created family. You can now add your family the way you always would > Place component, locate your family and load it. You will now see your cube in a project view. Here you will be able to set some custom parameters, such as material, width and height. And that is it! Extremely simple, and good foundation knowledge for creating Revit families. I will be posting part 2 in my Revit familys series soon. Hope this has helped someone who is having trouble, or someone who is just starting to use Revit. Any problems or questions, just leave a comment!

View Part 2 here – Creating simple parametric families in Revit – Part 2 Tables

Creating dormers in Revit Architecture

Today I am posting a small tutorial about creating dormer / dormer openings in Revit Architecture. It is a very simple process but has a few steps, so if you are having problems with dormers or interested in learning, continue reading.

The first step is to create some temporary walls as shown in the image below, indicated by the red rectangle. You should place these walls on the level under your roof, if you only have 2 levels, that’s fine, they will be cleaned up later and will not be visible. As usual take note of which wall type you are using. 

uploaded image

 You can now switch to a 3D view. You will see the walls protruding through the roof. I would recommend setting up levels to constrain the top of the walls, you can also define an unconstrained height. The next step of the proccess is to create a roof for these new walls you’ve created. Select ‘Roof by extrusion’. You will need to select a level to indicate which workplane you are working on. Choose the new level you have just created which is constraining the top of the walls as shown in the image below.  

uploaded image

 Once you’ve selected your work plane, you are ready to start sketching. This is another simple step. You need to create 2 lines as shown in the image below, each one connecting to the center point of the walls. Once you have created these 2 lines, highlight both of them, and use the blue node connector to drag up and create the angled profile that you desire.

uploaded image

You have now created a roof extrusion, but as you can see it doesn’t look as it should. What you need to do now is connect the new roof to the existing roof. You do this with the ‘Join Roof’ tool. Select the back edge of the roof, you can do this by pressing tab until the neccesary face is selected. Once selected, join the roof to the front face of the existing roof, again use tab to select the correct face. If you rotate the 3D view you will now see the roof is properly connected.

uploaded image

Now you need to connect the walls to the top of the roof. This is of course done with the ‘Attach top / base tool’. Select all 3 of the new walls you have created and click attach the TOP to the newly created roof. Once the walls are attached, reselect all 3 walls and attack the BASE to the main roof, this will resolve the problem of the walls being created on a lower level. 

uploaded image

The final step is creating the dormer opening in the roof. Right now in your model you have a new construction created on top of the roof, so a roof opening is needed. We do this with the ‘Dormer’ tool shown in the image below. Once you are in the dormer creation window select the lines of ALL edges of the new construction you have created. Use the blue arrows to position the lines on the inside of the walls. Trim / extend all edges to create a closed loop and create a group. Click the tick to finish.

uploaded image

You can now add a window or an opening to your dormer. Revit has many options to choose from, but if you can’t find something that fits then create a custom one from a generic window family template or alternatively search one of the online family databases where you may find what your looking for.

uploaded image

Hope this tutorial can help anyone who is having a hard time creating a dormer opening. As you can see it is very simple. If you have any problems or questions feel free to leave a comment.

Curtain wall / mullion corners in Revit

NOTE: This workflow no longer works in Revit 2014+ – refer to the comment section on this post for a method which works in Revit 2014. 

Curtain walls are one of the first major hurdles users face when creating simple projects in Revit Architecture for the first time. An example of one of the problems you could face would be that when you create joining curtain walls through an angle, Revit does not automatically generate the best design option for you. Instead it will give you a default option as seen in the image below.

uploaded image

In the above image you can see that Revit has automatically generated a faulty construction. Instead of creating a corner mullion  / join, it has simply added the 2 walls together with the standard curtain wall endings, resulting in a clash. I assume the reason for this is to allow the user the freedom to design and modify the join as they feel suitable. I will now demonstrate the very simple solution to this problem.

uploaded image

Following the instructions from the image above, select one of the corner mullions, at this point lets assume it doesn’t matter which one you select (certain join options work in different ways). Once you have one selected, you can click in the properties dialogue and change the element type from the drop down menu. As you can see there are various options which you can choose from; play around with them and find out what fits your design. Once you have decided, click “apply”.

uploaded image

You will receive an error from message as shown in the image above. It is just warning you that at present the new corner mullion is overlapping the neighbouring curtain region. Simply click “Delete Element(s)”. You have now removed the other mullion which was automatically generated from Revit and replaced it with your new corner connecting mullion. (Note: You will have to change the mullion type on each level)

uploaded image

In a plan view, you will now see that the join is a lot cleaner and the clash has been solved. As I said above, there are a lot of different design options, so if the “L join” doesn’t fit your design then play around and find one that does. You can always create a custom family if you don’t find what you are looking for!

uploaded image

Finally shown in a 3D view, the new mullions (top) and the original model (bottom) generated by Revit. As you can see the join has been cornered off and no longer clashes with the joining wall. This is a very simple design option in Revit, but it is very important to understand the basics of curtain walls before you try and create large projects with custom systems. If you are trying to create curved curtain walls but it is showing up as a straight wall in 3D view, make sure you have defined rules and standards for vertical grids on the walls, alternatively, use the “storefront” style of wall which is already pre-defined.